<script setup lang="ts">
import { fetchPubmedPublication } from "~/composables/usePubmedPublication";

const props = defineProps<{
  pmid: string;
  required?: boolean;
}>();
const emit = defineEmits<{
  (e: "update:pmid", v: string): void;
}>();

const rules = computed(() => {
  if (props.required) {
    return [(v: any) => !!v || "PubMed ID is required"];
  }
  return [];
});

const loading = ref(0);
const hint = ref("");
const fetchHint = async () => {
  const pmid = props.pmid;
  if (pmid) {
    loading.value += 1;
    try {
      const publication = await fetchPubmedPublication(pmid);
      if (pmid === props.pmid) {
        hint.value = publication.title;
      }
    } finally {
      loading.value -= 1;
    }
  } else {
    hint.value = "";
  }
};
const debouncedFetchHint = useDebounceFn(fetchHint, 500);
watch(() => props.pmid, debouncedFetchHint);
</script>

<template>
  <v-text-field
    :model-value="props.pmid"
    prefix="PMID:"
    placeholder="e.g. 18586236"
    :rules="rules"
    :hint="hint"
    :loading="loading !== 0 ? 'accent' : false"
    persistent-hint
    @update:modelValue="emit('update:pmid', $event)"
  />
</template>
